"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.configMiddleware = void 0;
const is = require("predicates");
const ConfigRequest_1 = require("../ConfigRequest");
const isConfigRequest = is.instanceOf(ConfigRequest_1.ConfigRequest);
const assertConfigProvider = is.assert(is.func, 'Invalid config provider - must be a function');
function configMiddleware(configProvider) {
    assertConfigProvider(configProvider);
    return function configMiddlewareExecutor(definition, next) {
        const hasAnyConfigRequest = definition.args.some(isConfigRequest);
        if (hasAnyConfigRequest) {
            return next(definition.modify({
                args: definition.args.map(arg => {
                    return isConfigRequest(arg) ? configProvider(arg) : arg;
                })
            }));
        }
        return next(definition);
    };
}
exports.configMiddleware = configMiddleware;
